/**************************************************************************
 *
 *	Copyright (C) 2001-2004 Franois LEIBER <http://leiber.free.fr>
 *
 *	This file is part of Jeu de la Vie.
 *
 *	Jeu de la Vie is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	Jeu de la Vie is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *************************************************************************/

.data

xdef moteurN
xdef boucle_toutN
xdef changer_reglesN
xdef scroll_gaucheN
xdef scroll_droiteN
xdef scroll_hautN
xdef scroll_basN

.even

/**********************************************************************************************************************************/

moteurN:
	move.l		%a5,-(%sp)		/* la sauvegarde automatique ne fonctionne pas ??? */
	move.l		Tampon,%a0		/* a0 : pointeur vers buffer */
	lea		0x4C44.w,%a1		/* a1 : pointeur vers vido */
	lea		(2482,%a0),%a4		/* a4 : pointeur zone pour savoir si une ligne est vide ou non */
	lea		(2610,%a0),%a5		/* a5 : pointeur vers tampon pour la mme chose que a4 */

ligne_suivante:
	cmp.b		#0,-1(%a4)		/* si trois lignes d'affile sont vides, inutile de calculer celle du milieu */
	bne.s		calcul_ligne
	cmp.b		#0,(%a4)
	bne.s		calcul_ligne
	cmp.b		#0,1(%a4)
	bne.s		calcul_ligne

	lea		(30,%a1),%a1
	lea		(12,%a0),%a0
	bra		passe_ligne

calcul_ligne:
	move.w		#11,%d1			/* pour les 12 octets de chaque ligne... */
	clr.b		(%a5)

	move.b		-31(%a1),%d4		/* calcule les trois cellules de gauche pour le premier test */
	move.b		-1(%a1),%d3
	move.b		29(%a1),%d5
	and.b		#0b00000001,%d4
	and.b		#0b00000001,%d3
	and.b		#0b00000001,%d5
	add.b		%d3,%d4
	add.b		%d5,%d4

octet_suivant:
	move.b		-29(%a1),%d0		/* calcul des trois cellules  droite de l'octet */
	move.b		1(%a1),%d5
	move.b		31(%a1),%d7
	and.w		#0b10000000,%d0
	and.w		#0b10000000,%d5
	and.w		#0b10000000,%d7
	add.w		%d5,%d0
	add.w		%d7,%d0

	move.b		-30(%a1),%d2
	move.b		(%a1),%d6
	move.b		30(%a1),%d3

/*	move.b		%d2,%d7
	add.w		%d6,%d7
	add.w		%d3,%d7
	add.w		%d0,%d7
	add.w		%d4,%d7

	cmp.w		#0,%d7
	bne		calcul			prtendue optimisation foireuse... */
	cmp.b		#0,%d2
	bne.s		calcul
	cmp.b		#0,%d6
	bne.s		calcul
	cmp.b		#0,%d3
	bne.s		calcul
	cmp.w		#0,%d0
	bne.s		calcul
	cmp.b		#0,%d4
	bne.s		calcul

	addq		#1,%a0			/* s'il n'y a aucune cellule autour de l'octet, ne sert  rien de faire le calcul */

	move.b		%d2,%d4			/* calcule quand mme les trois dernires cellules de l'octet pour le test suivant */
	and.b		#0b00000001,%d4
	and.b		#0b00000001,%d3
	and.b		#0b00000001,%d6
	add.b		%d3,%d4
	add.b		%d6,%d4

	bra		passe

calcul:
	lsr.w		#7,%d0
	move.w		%d2,%a2
	move.w		%d3,%a3

	and.w		#0b10000000,%d2		/* 1re cellule : colonne centrale */
	and.w		#0b10000000,%d3
	add.w		%d3,%d2
	lsr.w		#7,%d2
	add.b		%d2,%d4			/* la colonne de gauche est dj calcule */
	move.w		%a2,%d3			/* colonne de droite */
	move.w		%a3,%d7
	move.b		%d6,%d5
	and.b		#0b01000000,%d3
	and.b		#0b01000000,%d5
	and.b		#0b01000000,%d7
	add.b		%d5,%d3
	add.b		%d7,%d3
	lsr.b		#6,%d3
	add.b		%d3,%d4
	btst		#7,%d6			/* s'il y a ou non une cellule dans la case */
	bne.s		cell1
cell1ter:
	move.w		#0b0000010000000000,%d7
	bra.s		cell1bis
cell1:
	move.w		#0b0000011000000000,%d7
	add.b		#1,%d2
cell1bis:
	lsr.w		%d4,%d7
	and.b		#0b10000000,%d7

	move.w		%a2,%d4			/* 2me cellule : colonne de droite */
	and.b		#0b00100000,%d4
	move.w		%a3,%d5
	and.b		#0b00100000,%d5
	add.b		%d5,%d4
	move.b		%d6,%d5
	and.b		#0b00100000,%d5
	add.b		%d5,%d4
	lsr.b		#5,%d4
	add.b		%d4,%d2			/* on ajoute  la colonne de gauche */
	add.b		%d3,%d2			/* puis la colonne centrale */
	btst		#6,%d6			/* s'il y a ou non une cellule dans la case */
	bne.s		cell2
cell2ter:
	move.w		#0b0000001000000000,%d5
	bra.s		cell2bis
cell2:
	move.w		#0b0000011000000000,%d5
cell2bis:
	lsr.w		%d2,%d5
	and.b		#0b01000000,%d5
	add.b		%d5,%d7

	move.w		%a2,%d2			/* 3me cellule */
	and.b		#0b00010000,%d2
	move.w		%a3,%d5
	and.b		#0b00010000,%d5
	add.b		%d5,%d2
	move.b		%d6,%d5
	and.b		#0b00010000,%d5
	add.b		%d5,%d2
	lsr.b		#4,%d2
	add.b		%d2,%d3
	add.b		%d4,%d3
	btst		#5,%d6
	bne.s		cell3
cell3ter:
	move.w		#0b0000000100000000,%d5
	bra.s		cell3bis
cell3:
	move.w		#0b0000001100000000,%d5
cell3bis:
	lsr.w		%d3,%d5
	and.b		#0b00100000,%d5
	add.b		%d5,%d7

	move.w		%a2,%d3			/* 4me cellule */
	and.b		#0b00001000,%d3
	move.w		%a3,%d5
	and.b		#0b00001000,%d5
	add.b		%d5,%d3
	move.b		%d6,%d5
	and.b		#0b00001000,%d5
	add.b		%d5,%d3
	lsr.b		#3,%d3
	add.b		%d3,%d4
	add.b		%d2,%d4
	btst		#4,%d6
	bne.s		cell4
cell4ter:
	move.w		#0b0000000010000000,%d5
	bra.s		cell4bis
cell4:
	move.w		#0b0000000110000000,%d5
cell4bis:
	lsr.w		%d4,%d5
	and.b		#0b00010000,%d5
	add.b		%d5,%d7

	move.w		%a2,%d5			/* 5me cellule */
	and.b		#0b00000100,%d5
	move.w		%a3,%d4
	and.b		#0b00000100,%d4
	add.b		%d4,%d5
	move.b		%d6,%d4
	and.b		#0b00000100,%d4
	add.b		%d4,%d5
	lsr.b		#2,%d5
	add.b		%d5,%d2
	add.b		%d3,%d2
	btst		#3,%d6
	bne.s		cell5
cell5ter:
	move.w		#0b0000000001000000,%d4
	bra.s		cell5bis
cell5:
	move.w		#0b0000000011000000,%d4
cell5bis:
	lsr.w		%d2,%d4
	and.b		#0b00001000,%d4
	add.b		%d4,%d7

	move.w		%a2,%d2			/* 6me cellule */
	and.b		#0b00000010,%d2
	move.w		%a3,%d4
	and.b		#0b00000010,%d4
	add.b		%d4,%d2
	move.b		%d6,%d4
	and.b		#0b00000010,%d4
	add.b		%d4,%d2
	lsr.b		#1,%d2
	add.b		%d2,%d3
	add.b		%d5,%d3
	btst		#2,%d6
	bne.s		cell6
cell6ter:
	move.w		#0b0000000000100000,%d4
	bra.s		cell6bis
cell6:
	move.w		#0b0000000001100000,%d4
cell6bis:
	lsr.w		%d3,%d4
	and.b		#0b00000100,%d4
	add.b		%d4,%d7

	move.w		%a2,%d4			/* 7me cellule */
	and.b		#0b00000001,%d4
	move.w		%a3,%d3
	and.b		#0b00000001,%d3
	add.b		%d3,%d4
	move.b		%d6,%d3
	and.b		#0b00000001,%d3
	add.b		%d3,%d4
	add.b		%d4,%d5
	add.b		%d2,%d5
	btst		#1,%d6
	bne.s		cell7
cell7ter:
	move.w		#0b0000000000010000,%d3
	bra.s		cell7bis
cell7:
	move.w		#0b0000000000110000,%d3
cell7bis:
	lsr.w		%d5,%d3
	and.b		#0b00000010,%d3
	add.b		%d3,%d7

	add.b		%d0,%d2			/* 8me cellule */
	add.b		%d4,%d2
	btst		#0,%d6
	bne.s		cell8
cell8ter:
	move.w		#0b0000000000001000,%d5
	bra.s		cell8bis
cell8:
	move.w		#0b0000000000011000,%d5
cell8bis:
	lsr.w		%d2,%d5
	and.b		#0b00000001,%d5
	add.b		%d5,%d7


	move.b		%d7,(%a0)+		/* copie le rsultat dans le tampon, et incrmente les pointeurs */
	or.b		%d7,(%a5)

passe:
	addq		#1,%a1
	dbra		%d1,octet_suivant
	lea		(18,%a1),%a1
passe_ligne:
	addq		#1,%a4
	addq		#1,%a5
	cmp.w		#0x5784,%a1
	bne		ligne_suivante

	move.l		Tampon,%a0		/* recopie le tampon sur le terrain et boucle le tout */
	lea		0x4C44.w,%a1
	move.w		#95,%d0

	move.b		2610(%a0),(%a4)
	move.b		-1(%a5),2481(%a0)

copie_ligne:
	move.l	(%a0)+,(%a1)+ ; move.l  (%a0)+,(%a1)+ ; move.l  (%a0)+,(%a1)
	lea		(22,%a1),%a1
	move.b		-(%a5),-(%a4)
	btst		#7,-30(%a1)
	bne.s		allume_droite1
	bclr		#7,-18(%a1)
	bra.s		allume_droite2
allume_droite1:
	bset		#7,-18(%a1)
allume_droite2:
	btst		#0,-19(%a1)
	bne.s		allume_gauche1
	bclr		#0,-31(%a1)
	bra.s		allume_gauche2
allume_gauche1:
	bset		#0,-31(%a1)
allume_gauche2:
	dbra		%d0,copie_ligne

	move.l		(%sp)+,%a5

/**********************************************************************************************************************************/

boucle:						/* boucle le terrain en horizontal et dans les coins */
	move.l  0x5766,0x4C26 ; move.l  0x576A,0x4C2A ; move.l  0x576E,0x4C2E
	move.l  0x4C44,0x5784 ; move.l  0x4C48,0x5788 ; move.l  0x4C4C,0x578C

	btst		#0,0x5771
	bne.s		allume_bas_gauche1
	bclr		#0,0x4C25
	bra.s		allume_bas_gauche2
allume_bas_gauche1:
	bset		#0,0x4C25
allume_bas_gauche2:
	btst		#7,0x5766
	bne.s		allume_bas_droite1
	bclr		#7,0x4C32
	bra.s		allume_bas_droite2
allume_bas_droite1:
	bset		#7,0x4C32
allume_bas_droite2:
	btst		#0,0x4C4F
	bne.s		allume_haut_gauche1
	bclr		#0,0x5783
	bra.s		allume_haut_gauche2
allume_haut_gauche1:
	bset		#0,0x5783
allume_haut_gauche2:
	btst		#7,0x4C44
	bne.s		allume_haut_droite1
	bclr		#7,0x5790
	bra.s		allume_haut_droite2
allume_haut_droite1:
	bset		#7,0x5790
allume_haut_droite2:
	rts

/**********************************************************************************************************************************/

boucle_toutN:					/* boucle en vertical puis boucle se charge du reste */
	lea		0x4C44.w,%a1
	move.w		#95,%d0
change_ligne:
	lea		(30,%a1),%a1
	btst		#7,-30(%a1)
	bne.s		allume_droit1
	bclr		#7,-18(%a1)
	bra.s		allume_droit2
allume_droit1:
	bset		#7,-18(%a1)
allume_droit2:
	btst		#0,-19(%a1)
	bne.s		allume_gauch1
	bclr		#0,-31(%a1)
	bra.s		allume_gauch2
allume_gauch1:
	bset		#0,-31(%a1)
allume_gauch2:
	dbra		%d0,change_ligne

	bra		boucle

/**********************************************************************************************************************************/

changer_reglesN:					/* Charge les nouvelles rgles, stockes dans %d0 et %d1 */
	move.w		%d0,cell8ter+2
	add.w		%d0,%d0
	move.w		%d0,cell7ter+2
	add.w		%d0,%d0
	move.w		%d0,cell6ter+2
	add.w		%d0,%d0
	move.w		%d0,cell5ter+2
	add.w		%d0,%d0
	move.w		%d0,cell4ter+2
	add.w		%d0,%d0
	move.w		%d0,cell3ter+2
	add.w		%d0,%d0
	move.w		%d0,cell2ter+2
	add.w		%d0,%d0
	move.w		%d0,cell1ter+2

	add.w		%d1,%d1
	move.w		%d1,cell8+2
	add.w		%d1,%d1
	move.w		%d1,cell7+2
	add.w		%d1,%d1
	move.w		%d1,cell6+2
	add.w		%d1,%d1
	move.w		%d1,cell5+2
	add.w		%d1,%d1
	move.w		%d1,cell4+2
	add.w		%d1,%d1
	move.w		%d1,cell3+2
	add.w		%d1,%d1
	move.w		%d1,cell2+2
	move.w		%d1,cell1+2
	rts

/**********************************************************************************************************************************/

scroll_gaucheN:
	lea		0x578E.w,%a1
	move.w		#97,%d0

scrollg:
	btst		#7,2(%a1)
	bne.s		sg1
	and.b		#0xEE,%ccr
	bra.s		sg2
sg1:
	or.b		#0x11,%ccr
sg2:
	roxl.w (%a1) ; roxl.w -(%a1) ; roxl.w -(%a1)
	roxl.w -(%a1) ; roxl.w -(%a1) ; roxl.w -(%a1)
	lea		(-20,%a1),%a1
	dbra		%d0,scrollg
	rts

/**********************************************************************************************************************************/

scroll_droiteN:
	lea		0x4C26.w,%a1
	move.w		#97,%d0

scrolld:
	btst		#0,-1(%a1)
	bne.s		sd1
	and.b		#0xEE,%ccr
	bra.s		sd2
sd1:
	or.b		#0x11,%ccr
sd2:
	roxr.w (%a1)+ ; roxr.w (%a1)+ ; roxr.w (%a1)+
	roxr.w (%a1)+ ; roxr.w (%a1)+ ; roxr.w (%a1)
	lea		(20,%a1),%a1
	dbra		%d0,scrolld
	rts

/**********************************************************************************************************************************/

scroll_hautN:
	lea		0x4C44.w,%a0
	lea		0x4C62.w,%a1
	move.w		#95,%d0

scrollh:
	move.l (%a1)+,(%a0)+ ; move.l (%a1)+,(%a0)+ ; move.l (%a1),(%a0)
	lea		(22,%a0),%a0
	lea		(22,%a1),%a1
	dbra		%d0,scrollh
	rts

/**********************************************************************************************************************************/

scroll_basN:
	lea		0x5748.w,%a0
	lea		0x5766.w,%a1
	move.w		#95,%d0

scrollb:
	move.l (%a0)+,(%a1)+ ; move.l (%a0)+,(%a1)+ ; move.l (%a0),(%a1)
	lea		(-38,%a0),%a0
	lea		(-38,%a1),%a1
	dbra		%d0,scrollb
	rts
