/**************************************************************************
 *
 *  Copyright (C) 2001-2004 Franois LEIBER <http://leiber.free.fr>
 *
 *	This file is part of Jeu de la Vie.
 *
 *	Jeu de la Vie is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	Jeu de la Vie is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *************************************************************************/


#define OPTIMIZE_ROM_CALLS
#define NO_EXIT_SUPPORT
#define NO_CALC_DETECT
#define NO_AMS_CHECK

#define _89
#define fr_eng(x, y) (x)			// Replace by (y) to compile an English version
#define PUT_VERSION(STR) #STR "1.1"

#ifdef _89
	#define USE_TI89
	#define _89_92(x, y) (x)
#else
	#define USE_TI92PLUS
	#define USE_V200
	#define _89_92(x, y) (y)
#endif

#include <tigcclib.h>

#define Moteur (*moteur)
#define Boucle (*boucle)
#define ScrollGauche (*scrollGauche)
#define ScrollDroite (*scrollDroite)
#define ScrollHaut (*scrollHaut)
#define ScrollBas (*scrollBas)

enum {RIEN_FAIRE, CLIGNOTER_CURSEUR, ANIMER_CELLULE} ;
enum {NORMAL, GRAND = 7} ;

short x1 = 0, y1 = 0, x2 = 0, y2 = 0 ;

unsigned char *Alphabet = NULL, *Motifs = NULL, *Tampon = NULL ;
short *LargeurLettre = NULL ;
short TailleTerrain = _89_92(NORMAL, GRAND) ;
short MilieuTerrainX = 0, MilieuTerrainY = 0, Xmax = 0, Ymax = 0, LargeurTerrain = 0, HauteurTerrain = 0, LargeurOctetsTerrain = 0;

static SCR_RECT ECRAN = {{0, 0, 239, 127}} ;
static SCR_RECT TERRAIN = {{64, 2, 224, 125}} ;

////////////////////////////////////////////////////////////////////////////////////////////////////////

void (*moteur)(void) ;
void (*boucle)(void) ;
void (*scrollGauche)(void) ;
void (*scrollDroite)(void) ;
void (*scrollHaut)(void) ;
void (*scrollBas)(void) ;

void MoteurN()			{ asm("jsr moteurN" ::: "d0","d1","d2","d3","d4","d5","d6","d7","a0","a1","a2","a3","a4","a5") ; }
void BoucleN()			{ asm("jsr boucle_toutN" ::: "d0","a1") ; }
void ScrollGaucheN()	{ asm("jsr scroll_gaucheN" ::: "d0","a1") ; }
void ScrollDroiteN()	{ asm("jsr scroll_droiteN" ::: "d0","a1") ; }
void ScrollHautN()		{ asm("jsr scroll_hautN" ::: "d0","a0","a1") ; }
void ScrollBasN()		{ asm("jsr scroll_basN" ::: "d0","a0","a1") ; }

void MoteurG()			{ asm("jsr moteurG" ::: "d0","d1","d2","d3","d4","d5","d6","d7","a0","a1","a2","a3","a4","a5") ; }
void BoucleG()			{ asm("jsr boucle_toutG" ::: "d0","a1") ; }
void ScrollGaucheG()	{ asm("jsr scroll_gaucheG" ::: "d0","a1") ; }
void ScrollDroiteG()	{ asm("jsr scroll_droiteG" ::: "d0","a1") ; }
void ScrollHautG()		{ asm("jsr scroll_hautG" ::: "d0","a0","a1") ; }
void ScrollBasG()		{ asm("jsr scroll_basG" ::: "d0","a0","a1") ; }

////////////////////////////////////////////////////////////////////////////////////////////////////////

void set_taille_terrain()
{
#ifdef _89
	static short liste[] = {	111, 49, 159, 97, 96,  96, 12,
								111, 50, 159, 99, 96, 124, 20  } ;
#else
	static short liste[] = {	111, 49, 159,  97,  96,  96, 12,
								143, 63, 223, 125, 160, 124, 20  } ;
#endif

	MilieuTerrainX = liste[TailleTerrain] ;
	MilieuTerrainY = liste[TailleTerrain+1] ;
	Xmax = liste[TailleTerrain+2] ;
	Ymax = liste[TailleTerrain+3] ;
	LargeurTerrain = liste[TailleTerrain+4] ;
	HauteurTerrain = liste[TailleTerrain+5] ;
	LargeurOctetsTerrain = liste[TailleTerrain+6] ;

	moteur = TailleTerrain == NORMAL ? (void(*)(void))MoteurN : (void(*)(void))MoteurG ;
	boucle = TailleTerrain == NORMAL ? (void(*)(void))BoucleN : (void(*)(void))BoucleG ;
	scrollGauche = TailleTerrain == NORMAL ? (void(*)(void))ScrollGaucheN : (void(*)(void))ScrollGaucheG ;
	scrollDroite = TailleTerrain == NORMAL ? (void(*)(void))ScrollDroiteN : (void(*)(void))ScrollDroiteG ;
	scrollHaut = TailleTerrain == NORMAL ? (void(*)(void))ScrollHautN : (void(*)(void))ScrollHautG ;
	scrollBas = TailleTerrain == NORMAL ? (void(*)(void))ScrollBasN : (void(*)(void))ScrollBasG ;

	ClrScr() ;

	DrawLine(62, 0, 62, TailleTerrain == NORMAL ? 99 : 127, 4) ;
	#ifdef _92
		if (TailleTerrain == NORMAL)
			DrawLine(161, 0, 161, 99, 4) ;
		else
			DrawLine(225, 0, 225, 127, 4) ;
	#endif
}
